module mFlashMem(adr,dat);
	input [12:0] adr;
	output [13:0] dat;
	reg [13:0] romdat;
	assign dat=romdat;
	always @(adr) begin
		case (adr)
		14'h0000 : romdat=14'h2809;	//goto    Start
									//org 4
		14'h0004 : romdat=14'h0A8C;	//incf    Work,F
		14'h0005 : romdat=14'h080C;	//movf    Work,W
		14'h0006 : romdat=14'h0086;	//movwf   PORTB
		14'h0007 : romdat=14'h110B;	//bcf             INTCON,2
		14'h0008 : romdat=14'h0009;	//retfie
									//Start
		14'h0009 : romdat=14'h3020;	//movlw   0x20
		14'h000A : romdat=14'h0083;	//movwf   STATUS  ;Select Bank1   
		14'h000B : romdat=14'h30FF;	//movlw   0xff
		14'h000C : romdat=14'h0085;	//movwf   TRISA   ;porta=input
		14'h000D : romdat=14'h3007;	//movlw   0x07
		14'h000E : romdat=14'h0081;	//movwf   OPTION_REG
		14'h000F : romdat=14'h0103;	//clrw
		14'h0010 : romdat=14'h0086;	//movwf   TRISB   ;portb=output
		14'h0011 : romdat=14'h0083;	//movwf   STATUS
		14'h0012 : romdat=14'h018C;	//clrf    Work
		14'h0013 : romdat=14'h30A0;	//movlw   0xa0
		14'h0014 : romdat=14'h008B;	//movwf   INTCON  ;Enable Timer Int
									//loop
		14'h0015 : romdat=14'h2815;	//goto    loop
        default : romdat=14'h3fff;
		endcase
	end
endmodule

