//Interrupt Controller
module mIntrc(reset,clk,Q,portb,opt6,tovf,iret,sel,wr_fr,datain,intcon_out,intr);
	input reset,clk,Q;
    input [7:0] portb;
    input opt6,tovf,iret,sel,wr_fr;
    input [7:0] datain;
    output [7:0] intcon_out;
	output intr;
    reg [7:4] oportb;
    reg rb0;
    reg [7:0] intcon;
    wire [2:0] ireq;
	wire irqrst;
	reg dirq;
	wire irqreq;
	wire dportb;

    assign intcon_out=intcon;
	
    //INTCON
    always@(posedge clk or posedge reset) begin
        if(reset) begin
            intcon<=8'h0;
        end else if(Q) begin
			if(intr)
				intcon<=(intcon & 8'h7f);
            else if((ireq!=3'b000)||(iret))
                intcon<=(intcon | {iret,4'h0,ireq});
            else if(sel & wr_fr)
                intcon<=(datain | {iret,4'h0,ireq});
       end
	end

	assign irqrst=(reset | dirq);

	//RB0 Interrupt
	assign irqreq=(portb[0] ^ ~opt6);
	always@(posedge irqreq or posedge irqrst) begin
		if(irqrst) begin
			rb0<=1'b0;
		end else begin
			rb0<=1'b1;
		end
	end

	//DIRQ
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			dirq<=1'b0;
		end else if(Q) begin
			dirq<=rb0;
		end
	end

	//RB7-4 Interrupt
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			oportb<=4'h0;
		end else if(Q) begin
			oportb<=portb[7:4];
		end
	end

	assign dportb=(oportb != portb[7:4]) ? 1'b1 : 1'b0;
	assign ireq={tovf,rb0,dportb};
	assign intr=((intcon[0]&intcon[3])|(intcon[1]&intcon[4])|(intcon[2]&intcon[5]))&intcon[7];
	
endmodule
