module mReset(reset,oscout);
	output reset,oscout;
	reg [15:0] rcnt;
	reg resout;
	wire cntup,iosc;
	
	IntOSC osc(1'b1,iosc);
	assign cntup=(rcnt!=16'h8000) ? 1'b1 : 1'b0;
	assign reset=~rcnt[15];
	assign oscout=iosc;
	//Power On Reset
	always @(posedge iosc) begin
		begin
			if(cntup) begin
				rcnt=rcnt+1'b1;
			end
		end
	end
endmodule

module mTmgGen(reset,clk,Qout);
	input reset,clk;
	output Qout;
	//1 clock cycle	==============================
	assign Qout=1'b1;	
	//============================================
	//4 clock cycle===============================
	/*
	reg [1:0] clkcnt;
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			clkcnt<=2'h0;
		end else begin
			clkcnt<=clkcnt+1'b1;
		end
	end
	assign Qout=(clkcnt==2'b11) ? 1'b1 : 1'b0;
	*/
	//============================================

endmodule

module mStep(reset,clk,sw,Qin,Qout);
	input reset,clk,sw,Qin;
	output Qout;
	reg dsw;
	reg rQout;
	wire step;
	assign Qout=Qin & rQout & ~reset;
	
	assign step=dsw & ~sw;
	always @(posedge clk or posedge reset) begin
		if(reset) begin
			dsw<=1'b1;
		end else begin
			dsw<=sw;
		end
	end

	always@(posedge clk or posedge reset)begin
		if(reset) begin
			rQout<=1'b0;
		end else begin
			if(step)
				rQout<=1'b1;
			else if(Qin)
				rQout<=1'b0;
		end
	end
	

endmodule
